#pragma fragment
#ifdef GL_ES
precision mediump float;
#endif
#pragma common

varying float v_dist;
varying float v_border;
varying float v_waveWeight;

#pragma vertex

attribute vec3 a_position;
uniform   mat4 u_model;
uniform   mat4 u_view;
uniform   mat4 u_projection;
uniform vec3 u_radius;
uniform float u_time;

void main()
{
    float d = mix(u_radius.x, u_radius.y, a_position.z);
    gl_Position = u_projection * u_view * u_model * vec4(d * a_position.xy, 0.0, 1.0);

    v_dist = d - u_radius.x;
    v_waveWeight = sin(u_time) * 0.5 + 0.5;
    v_border = mix(u_radius.z, u_radius.z * 1.5, v_waveWeight);
}

#pragma fragment

uniform vec4 u_color;


void main()
{
    float w = clamp(v_dist / v_border, 0.0, 1.0);

    float fadeInW = clamp(v_dist / 15.0, 0.0, 1.0); // todo: 15.0 to uniforms
    fadeInW = fadeInW * fadeInW * fadeInW;

    float alphaFill = 0.3;
    float alphaBorder = (0.56 + v_waveWeight * 0.24);
    float alpha = mix(alphaBorder, alphaFill, w) * fadeInW;
    vec3 c = vec3(1.0, 0.0, 0.0);
    gl_FragColor = vec4(c, alpha);
}
