#pragma fragment
#ifdef GL_ES
precision mediump float;
#endif
#pragma common

varying vec2 v_texCoord;
varying vec4 v_color;

#pragma vertex

attribute vec2 a_position;
attribute vec2 a_uv;
attribute vec4 a_color;
uniform mat4 u_view;
uniform mat4 u_projection;

void main()
{
    gl_Position = u_projection * u_view * vec4(a_position, 0.0, 1.0);
    v_color = a_color;
    v_texCoord = a_uv;
}

#pragma fragment

uniform sampler2D u_texture;
uniform vec4 u_fillColor;

void main()
{
    vec4 tex = texture2D(u_texture, v_texCoord);
    gl_FragColor = mix(tex * v_color, vec4(u_fillColor.rgb, tex.a * v_color.a), u_fillColor.a);
}
