#pragma fragment
#ifdef GL_ES
precision mediump float;
#endif

#pragma common

varying vec2 v_uv;
varying float v_quadR;

#pragma vertex

attribute vec2 a_position;
uniform   mat4 u_model;
uniform   mat4 u_view;
uniform   mat4 u_projection;

uniform vec3 u_tr;

void main()
{
    gl_Position = u_projection * u_view * u_model * vec4(a_position * u_tr.z + u_tr.xy, 0.0, 1.0);
    v_uv = a_position;
    v_quadR = u_tr.z;
}

#pragma fragment

uniform vec3 u_circle;
uniform float u_drawOuterCircle;
uniform vec4 u_wave12;
uniform vec4 u_wave34;
uniform vec3 u_waveParams;

float waveEdge(vec2 w, float d) {
    float t = w.y;
    float wr = w.x * t;
    float edge = 1.0 - max(smoothstep(0.0, mix(60.0, 10.0, t), wr - d), smoothstep(0.0, 2.0, d - wr));
    return edge * (1.0 - t);
}

void main()
{
    float d = sqrt(dot(v_uv, v_uv)) * v_quadR;
    float circleEdge = mix(0.0, 1.0 - smoothstep(0.0, u_circle.y, abs(u_circle.x - d)), u_drawOuterCircle);

    float edge = max(max(max(waveEdge(u_wave12.xy, d), waveEdge(u_wave12.zw, d)), waveEdge(u_wave34.xy, d)), waveEdge(u_wave34.zw, d));

    float rPercent = u_circle.z;

    gl_FragColor = vec4(1.0, 1.0, 0.5, edge * 0.25 + circleEdge * rPercent * 0.25);
}
