#pragma fragment
#ifdef GL_ES
precision mediump float;
#endif
#pragma common

varying vec2 v_texCoord;

#pragma vertex

attribute vec3 a_position;
attribute vec2 a_uv;

uniform   mat4 u_model;
uniform   mat4 u_view;
uniform   mat4 u_projection;

void main()
{
    gl_Position = u_projection * u_view * u_model * vec4(a_position.xy, 0.0, 1.0);
    v_texCoord = a_uv;
}

#pragma fragment

uniform vec4 u_color;
uniform sampler2D u_tex;

void main()
{
    vec4 tex = texture2D(u_tex, v_texCoord);
    gl_FragColor = tex * u_color;
}
