#pragma fragment
#ifdef GL_ES
    precision highp float;
#endif

#pragma common

varying vec2 v_texCoord;
varying vec2 v_tileScale;
varying vec4 v_quadParams;
varying float v_alpha;

#pragma vertex

attribute vec3 a_positionAlpha;
attribute vec4 a_quadParams;
attribute vec3 a_scaleRot;

uniform   mat4 u_model;
uniform   mat4 u_view;
uniform   mat4 u_projection;

void main()
{
    vec4 wPos = u_model * vec4(a_positionAlpha.xy, 0.0, 1.0);
    gl_Position = u_projection * u_view * wPos;

    float s = sin(a_scaleRot.z);
    float c = cos(a_scaleRot.z);
    mat2 tileRotationMat = mat2(c, s, -s, c);
    v_texCoord = tileRotationMat * wPos.xy;

    v_tileScale = a_scaleRot.xy;
    v_quadParams = a_quadParams;
    v_alpha = a_positionAlpha.z;
}

#pragma fragment

uniform sampler2D u_texture;
uniform float u_opacity;

void main()
{
    vec2 coord = v_quadParams.xy + fract(v_texCoord * v_tileScale) * v_quadParams.zw;
    gl_FragColor = texture2D(u_texture, coord);
    gl_FragColor.a *= v_alpha * u_opacity;
}
